// Generated by CoffeeScript 2.7.0
(function() {
  // ***** BEGIN LICENSE BLOCK *****
  // Copyright (c) 2011-2012 VMware, Inc.

  // For the license see COPYING.
  // ***** END LICENSE BLOCK *****
  var EventSourceReceiver, transport, utils;

  utils = require('./utils');

  transport = require('./transport');

  EventSourceReceiver = (function() {
    class EventSourceReceiver extends transport.ResponseReceiver {
      doSendFrame(payload) {
        var data;
        // Beware of leading whitespace
        data = ['data: ', utils.escape_selected(payload, '\r\n\x00'), '\r\n\r\n'];
        return super.doSendFrame(data.join(''));
      }

    };

    EventSourceReceiver.prototype.protocol = "eventsource";

    return EventSourceReceiver;

  }).call(this);

  exports.app = {
    eventsource: function(req, res) {
      var headers, origin;
      if (!req.headers['origin'] || req.headers['origin'] === 'null') {
        origin = '*';
      } else {
        origin = req.headers['origin'];
        res.setHeader('Access-Control-Allow-Credentials', 'true');
      }
      res.setHeader('Content-Type', 'text/event-stream');
      res.setHeader('Access-Control-Allow-Origin', origin);
      res.setHeader('Vary', 'Origin');
      headers = req.headers['access-control-request-headers'];
      if (headers) {
        res.setHeader('Access-Control-Allow-Headers', headers);
      }
      res.writeHead(200);
      // Opera needs one more new line at the start.
      res.write('\r\n');
      transport.register(req, this, new EventSourceReceiver(req, res, this.options));
      return true;
    }
  };

}).call(this);
